image: docker:git

services:
- docker:dind

variables:
  CONTAINER_TEST_IMAGE: registry.gitlab.com/stoeps/$CI_PROJECT_NAME:$CI_BUILD_REF_NAME
  CONTAINER_RELEASE_IMAGE: registry.gitlab.com/stoeps/$CI_PROJECT_NAME:latest
  GIT_SUBMODULE_STRATEGY: recursive

before_script:
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  - git submodule sync --recursive 
  - git submodule update --init --recursive

stages:
  - build
  - test
  - release
  - conversion
  - deploy

build:
  stage: build
  script:
    - docker build -t $CONTAINER_TEST_IMAGE docker-asciidoctor
    - docker push $CONTAINER_TEST_IMAGE
  only:
    changes:
      - docker-asciidoctor/Dockerfile
    refs:
      - master
    variables:
      - $BUILDCONTAINER

test 1:
  stage: test
  script:
    - echo "Run tests here"
    - docker run -t --rm $CONTAINER_TEST_IMAGE asciidoctor -v | grep "Asciidoctor"
  only:
    changes:
      - docker-asciidoctor/Dockerfile
    refs:
      - master
    variables:
      - $BUILDCONTAINER

test 2:
  stage: test
  script:
    - docker run -t --rm $CONTAINER_TEST_IMAGE asciidoctor-revealjs -v
  only:
    changes:
      - docker-asciidoctor/Dockerfile
    refs:
      - master
    variables:
      - $BUILDCONTAINER

release-image:
  stage: release
  script:
    - echo "Tag Image and push to registry"
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE
  only:
    changes:
      - docker-asciidoctor/Dockerfile
    refs:
      - master
    variables:
      - $BUILDCONTAINER

pdf:personal:
  stage: conversion
  script:
    - echo "Start Asciidoctor conversion"
    - echo $CONTAINER_IMAGE:$CI_COMMIT_SHA
    - docker run -t --rm -v $(pwd)/documents-personal:/documents/ -v $(pwd)/images:/images -v $(pwd)/scripts:/scripts $CONTAINER_RELEASE_IMAGE /scripts/pdf-conversion.sh
    - cp documents-personal/*.pdf public/pdf-personal
  artifacts:
    name: "pdf-personal-$CI_COMMIT_TAG"
    paths:
      - public/pdf-personal
    expire_in: 2 hours
  except:
    variables:
      - $BUILDCONTAINER

pdf:work:
  stage: conversion
  script:
    - echo "Start Asciidoctor conversion"
    - echo $CONTAINER_IMAGE:$CI_COMMIT_SHA
    - docker run -t --rm -v $(pwd)/documents-work:/documents/ -v $(pwd)/images:/images -v $(pwd)/scripts:/scripts -v $(pwd)/pdftheme:/pdftheme/ $CONTAINER_RELEASE_IMAGE /scripts/pdf-work-conversion.sh
    - cp documents-work/*.pdf public/pdf-work
  artifacts:
    name: "pdf-work-$CI_COMMIT_TAG"
    paths:
      - public/pdf-work
    expire_in: 2 hours
  except:
    variables:
      - $BUILDCONTAINER

html:
  stage: conversion
  script:
    - echo "Start Asciidoctor conversion"
    - echo $CONTAINER_IMAGE:$CI_COMMIT_SHA
    - docker run -t --rm -v $(pwd)/documents-work:/documents/ -v $(pwd)/images:/images -v $(pwd)/scripts:/scripts $CONTAINER_RELEASE_IMAGE /scripts/html-work-conversion.sh
    - cp documents-work/*.html public/html-work
    - docker run -t --rm -v $(pwd)/documents-personal:/documents/ -v $(pwd)/images:/images -v $(pwd)/scripts:/scripts $CONTAINER_RELEASE_IMAGE /scripts/html-conversion.sh
    - cp documents-personal/*.html public/html-personal
  artifacts:
    name: "html-$CI_COMMIT_TAG"
    paths:
      - public/html-work
      - public/html-personal
      - images
    expire_in: 2 hours
  except:
    variables:
      - $BUILDCONTAINER

reveal:
  stage: conversion
  script:
    - echo "Start Asciidoctor conversion"
    - echo $CONTAINER_IMAGE:$CI_COMMIT_SHA
    - docker run -t --rm -v $(pwd)/presentations:/documents/ -v $(pwd)/images:/images -v $(pwd)/scripts:/scripts $CONTAINER_RELEASE_IMAGE /scripts/reveal-conversion.sh
    - cp presentations/*.html public/presentations
  artifacts:
    name: "html-$CI_COMMIT_TAG"
    paths:
      - public/presentations
      - images
    expire_in: 2 hours
  except:
    variables:
      - $BUILDCONTAINER

pages:
  stage: deploy
  dependencies:
    - html
    - reveal
    - pdf:personal
    - pdf:work
  script:
    - cp -arvf images/* public/images/
    - sh scripts/create-index.sh
    - chmod +r public -R
  artifacts:
    paths:
      - public
    expire_in: 1 hour
  only:
    refs:
      - master # this job will affect only the 'master' branch
  except:
    variables:
      - $BUILDCONTAINER
